<?php
$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"] = (@$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] ?: array()) + array("_31767d7ad58e706dbf47b7a51a0fe" . "6c4" => base64_decode("Y291" . "bnQ="), "_39b6f979" . "f725d2d06" . "6951011e1" . "554c14" => base64_decode("YXJyYX" . "lfZGlm" . "Zl9rZX" . "k="), "_a8391504b805b5d572e9b1a5c5d0" . "169e" => base64_decode("Tm8gbGlzdCBpZ" . "A=="), "_f5e940c614" . "f55e70f210d" . "f8306ffbd17" => base64_decode("YXJyYXlfZm" . "lsbF9rZXlz"), "_1d5727e95902d6ca0" . "a94581ac86acf26" => base64_decode("QXR0ZW1wdCB0byBsb2FkIGF0dGVu" . "ZGVlcyBsaXN0IHdpdGggbm8gbGlz" . "dF9pZA=="), "_cce0d019091a193c2ea09" . "8ab902d8821" => base64_decode("QXR0ZW1wdCB0byBzYXZlIGF0dGVuZGVlcyB3aXRoIG5vIGxpc3RfaWQ" . "h"), "_c06c961f393742ecfd52b7" . "2263ac9470" => base64_decode("aW50" . "dmFs"), "_c336a736f98472e69eb00" . "017dda5a17e" => base64_decode("dHJpZ2d" . "lcl9lcn" . "Jvcg=="), "_4d2b763f00ba1e8001879" . "ba79a849269" => base64_decode("YXJyYXlfaW50ZXJzZ" . "WN0X2tleQ=="));
abstract class CalendarEventParticipants extends ErrorHandler
{
    protected $is_list_loaded;
    protected $list_id = false;
    protected $users = array();
    protected $deleted_users = array();
    protected $new_users = array();
    protected $old_users = array();
    
    
    
    
    protected $event;
    public function __construct(CalendarObject $event)
    {
        $this->event = $event;
        $this->is_list_loaded = false;
    }
    
    
    
    
    
    
    public function SetUsers($_c9cc2169cfc80b4728d6b39dfdcba6bb)
    {
        
        
        $_c9cc2169cfc80b4728d6b39dfdcba6bb = $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_f5e940c614f55e" . "70f210df8306ffb" . "d17"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, 1);
        
        
        $this->deleted_users = $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_39b6f979f725d2d066951011e1" . "554c14"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->new_users = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_39b6f979f725d2d066951" . "011e1554c14"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, $this->users);
        $this->old_users = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_4d2b763f00ba1e8001879ba79a84926" . "9"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->is_list_loaded = true;
    }
    public function Load()
    {
        if (!$this->list_id) {
            throw new Exception($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_1d5727e95902d6ca0a" . "94581ac86acf26"]);
        }
        $this->deleted_users = array();
        $this->new_users = array();
        $this->old_users = array();
        $this->is_list_loaded = true;
    }
    public function SetListId($_0ea4e32b57963ac0cb3057e03e9aef64)
    {
        $this->list_id = $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_c06c961f393742ecfd5" . "2b72263ac9470"]($_0ea4e32b57963ac0cb3057e03e9aef64);
        if ($_0ea4e32b57963ac0cb3057e03e9aef64 === null) {
            $this->is_list_loaded = true;
        }
    }
    
    
    
    
    
    
    public function isAttendeesChanged()
    {
        return $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_31767d7ad58e706dbf47b7a51a0fe6c" . "4"]($this->new_users) > 0 || $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_31767d7ad58e706dbf47b7a51a" . "0fe6c4"]($this->deleted_users) > 0;
    }
    public function Save()
    {
        if (!$this->list_id) {
            $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_c336a736f9847" . "2e69eb00017dda" . "5a17e"]($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_a8391504b805b5d572e9b1a5" . "c5d0169e"]);
            throw new Exception($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_cce0d019" . "091a193c2" . "ea098ab90" . "2d8821"]);
        }
        $this->SaveNewUsers();
        $this->DeleteUnattendedUsers();
        foreach ($this->new_users as $user_id => $_c96f552040dea8086bf8bdd70059542f) {
            $this->users[$user_id] = $_c96f552040dea8086bf8bdd70059542f;
        }
        
        
        $this->users = $GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_39b6f979f725d2d066" . "951011e1554c14"]($this->users, $this->deleted_users);
        
        
    }
    public function GetNewUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return $this->new_users;
    }
    public function GetAllUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->users;
    }
    public function GetOldUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->old_users;
    }
    public function GetDeletedUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->deleted_users;
    }
    protected abstract function SaveNewUsers();
    protected abstract function DeleteUnattendedUsers();
}